MODULE Acchk;
  FROM FIO IMPORT File, OpenRead, Close, Create, RdCard, RdLngCard,
                  WrStr, WrLn, StandardOutput;
  FROM CoreMath IMPORT floor;
  CONST Nmax = 45;
        eps = 1.E-11;
        ErrMes = "Test rejected";
  VAR FHandle : File;
      N, ind : CARDINAL;
      S, Sol : LONGCARD;
      Fib : ARRAY [0..Nmax] OF TEMPREAL;
      Account : ARRAY [1..Nmax] OF LONGCARD;
      x1, x2 : TEMPREAL;
BEGIN
  FHandle := OpenRead("Account.IN"); (* ⠥ 室 ,   *)
  N := RdCard(FHandle);              (*    ஢ப *)
  S := RdLngCard(FHandle);
  Close(FHandle);                    (*   Handle 㤥 ᯮ짮 *)
                                     (*   뢮 १⮢         *)
  IF N = 3    (* ᮡ 砩  ᬮ ⤥쭮 *)
    THEN Sol := S -1;
    ELSE
      Fib[0] := 0.;  (* 塞 ⠡ ᥫ  *)
      Fib[1] := 1.;
      FOR ind := 2 TO Nmax DO
        Fib[ind] := Fib[ind-1] + Fib[ind-2]
      END;

      x1 := Fib[N-3] * TEMPREAL(S);     (*  ᫠ 襭 *)
      x2 := Fib[N-4] * TEMPREAL(S);
      Sol := LONGCARD(ABS(floor(LONGREAL(x1/Fib[N-1])) - floor(LONGREAL(x2/Fib[N-2]))));
      IF ODD(N)
        THEN
          IF x2 - TEMPREAL(floor(LONGREAL(x2 / Fib[N-2]))) * Fib[N-2] < eps
            THEN DEC(Sol)
          END
        ELSE
          IF x1 - TEMPREAL(floor(LONGREAL(x1 / Fib[N-1]))) * Fib[N-1] < eps
            THEN DEC(Sol)
          END
      END
  END;

  FHandle := OpenRead("Account.OUT");
  Account[1] := RdLngCard(FHandle); (*  ᫮ 襭 祭 *)
  IF Sol # Account[1]
    THEN
      WrStr(StandardOutput, ErrMes);
      WrLn(StandardOutput);
      WrStr(StandardOutput, "Bad solution counter");
      WrLn(StandardOutput);
      RETURN
  END;

  IF Sol > 0
    THEN
      FOR ind := 1 TO 2 DO
        Account[ind] := RdLngCard(FHandle);
        IF (Account[ind] = 0) OR (Account[ind] >= S)
          THEN
            WrStr(StandardOutput, ErrMes);
            WrLn(StandardOutput);
            WrStr(StandardOutput, "Out of range solution");
            WrLn(StandardOutput);
            RETURN
        END
      END;

      Close(FHandle);

      FOR ind := 3 TO N DO
        Account[ind] := Account[ind-1] + Account[ind-2]
      END;
      IF Account[N] # S
        THEN
          WrStr(StandardOutput, ErrMes);
          WrLn(StandardOutput);
          WrStr(StandardOutput, "Invalid solution");
          WrLn(StandardOutput);
          RETURN
      END
  END;

  WrStr(StandardOutput, "Test passed");
  WrLn(StandardOutput)
END Acchk.